from flask import current_app, request
from flask_shopp.utils.message import to_dict_msg
from flask_shopp.models import User
from itsdangerous import TimedJSONWebSignatureSerializer as Serializer
import functools


def generate_auth_token(uid,expiration):
    # 创建加密对象
    # 第一个参数是内部的私钥，这里写在共用的配置信息里了，如果只是测试可以写死
    # 第二个参数是有效期(秒)
    s = Serializer(current_app.config['SECRET_KEY'],expires_in=expiration)
    # 生成token
    print(type(s))
    # 接收用户id转换与编码
    return s.dumps({'id':uid}).decode()



def verify_auth_token(token_str):
    s = Serializer(current_app.config['SECRET_KEY'])
    try:
        # 转换为字典
        data = s.loads(token_str)
    except Exception:
        return None
    # 拿到转换后的数据，根据模型类去数据库查询用户信息
    usr = User.query.filter_by(id = data['id'])
    return usr
# generate_auth_token()

def login_required(view_func):
    functools.wraps(view_func)
    def verify_token(*args,**kwargs):
        try:
            token = request.headers['token']
        except Exception:
            return to_dict_msg(10016)
        s = Serializer(current_app.config['SECRET_KEY'])
        try:
            data = s.loads(token)
        except Exception:
            return to_dict_msg(10017)
        return view_func(*args,**kwargs)
    return  verify_token